<?php

	// Definisikan feedback404() jika belum ada
	function feedback404() {
		header("HTTP/1.0 404 Not Found");
		echo "404 Not Found";
		// Anda juga bisa memasukkan halaman kustom 404 di sini
	}

	$filename = "list.txt";
	$lines = file($filename, FILE_IGNORE_NEW_LINES | FILE_SKIP_EMPTY_LINES);

	// Spintax - A helper class to process Spintax strings.
	class Spintax
	{
		// Set seed to make the spinner predictable. 
		public function seed(mixed $seed)
		{
			mt_srand(crc32($seed));
		}

		public function process(string $text)
		{
			return preg_replace_callback(
				'/\{(((?>[^\{\}]+)|(?R))*?)\}/x',
				function ($match) {
					$text = $this->process($match[1]);
					$parts = explode('|', $text);
					return $parts[mt_rand(0, count($parts) - 1)];
				},
				$text
			);
		}

		/**
		 * If you want highest randomness,
		 * this is the method to use.
		 * Note: Seed has no effect.
		 *
		 * Last updated: 2023-10-26
		 */
		public function spin(string $text)
		{
			$pattern = '/{([^{}]+)}/';
			while (preg_match($pattern, $text)) {
				$text = preg_replace_callback($pattern, function ($matches) {
					$options = explode('|', $matches[1]);
					return $options[ random_int(0, count($options) - 1) ];
				}, $text);
			}

			return $text;
		}
	}

	foreach ($lines as $target_string) {
		$target_string = strtolower($target_string);
		$BRAND = strtoupper($target_string);
		$target_string = str_replace(" ", "-", $target_string); // merubah kw untuk folder dash
		$target_string = str_replace("---", "-", $target_string);
		$target_string = str_replace("&", "%26", $target_string);
		$sAmplink = $target_string."/amp/amp.html"; // folder untuk amp
		$BRANDS = str_replace(" ", "%20", $BRAND);
		
		// Mendapatkan informasi host dan skema dari URL saat ini
		//$protocol = isset($_SERVER['HTTPS']) && $_SERVER['HTTPS'] === 'on' ? 'https' : 'http';
		$protocol = 'http';
		$protocolamp = 'https';
		$host = $_SERVER['HTTP_HOST'];
		
		// Mendapatkan direktori tempat skrip berada
		$dir = rtrim(dirname($_SERVER['PHP_SELF']), '/');

		// Set $urlPath sesuai dengan host, path, dan nama file
		//$urlPath = "$protocol://$host$dir/$target_string.html";
		$urlPath = "$protocol://$host/"; //url domain utama
		$urlCano = "$protocol://$host/$target_string"; // url canonical
		$urlAmp = "$protocolamp://$host/$sAmplink"; // url amp
			
		
			
		// Include file template.php dan teruskan variabel-variabel yang diperlukan
		ob_start(); // Mulai buffer output
		include 'template.php';
		$html_content = ob_get_clean(); // Ambil konten dari buffer output dan bersihkan buffer
		
		mkdir($target_string);
		// Buat file HTML sesuai dengan isi list.txt
		file_put_contents("$target_string/index.html", $html_content);
	}

	date_default_timezone_set('Asia/Jakarta');
	$currentTime = date('Y-m-d\TH:i:sP');
	echo "FILE DONE CREATE!";
?>
